/* The copyright in this software is being made available under the BSD
 * License, included below. This software may be subject to other third party
 * and contributor rights, including patent rights, and no such rights are
 * granted under this license.  
 *
 * Copyright (c) 2010-2011, ITU/ISO/IEC
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions are met:
 *
 *  * Redistributions of source code must retain the above copyright notice,
 *    this list of conditions and the following disclaimer.
 *  * Redistributions in binary form must reproduce the above copyright notice,
 *    this list of conditions and the following disclaimer in the documentation
 *    and/or other materials provided with the distribution.
 *  * Neither the name of the ITU/ISO/IEC nor the names of its contributors may
 *    be used to endorse or promote products derived from this software without
 *    specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
 * AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER OR CONTRIBUTORS
 * BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
 * CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
 * SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
 * INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
 * CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
 * ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF
 * THE POSSIBILITY OF SUCH DAMAGE.
 */

/** \file     decmain.cpp
    \brief    Decoder application main
*/

#include <stdlib.h>
#include <stdio.h>
#include <time.h>
#include "TAppDecTop.h"

//! \ingroup TAppDecoder
//! \{

bool g_md5_mismatch = false; ///< top level flag that indicates if there has been a decoding mismatch

// ====================================================================================================================
// Main function
// ====================================================================================================================

int main(int argc, char* argv[])
{
  TAppDecTop  cTAppDecTop;

  // print information
  fprintf( stdout, "\n" );
  fprintf( stdout, "HM software: Decoder Version [%s]", NV_VERSION );
  fprintf( stdout, NVM_ONOS );
  fprintf( stdout, NVM_COMPILEDBY );
  fprintf( stdout, NVM_BITS );
  fprintf( stdout, "\n" );

  // create application decoder class
  cTAppDecTop.create();

  // parse configuration
  if(!cTAppDecTop.parseCfg( argc, argv ))
  {
    cTAppDecTop.destroy();
    return 1;
  }

  // starting time
  double dResult;
  long lBefore = clock();

  // call decoding function
  cTAppDecTop.decode();

  if (g_md5_mismatch)
  {
    printf("\n\n***ERROR*** A decoding mismatch occured: signalled md5sum does not match\n");
  }

  // ending time
  dResult = (double)(clock()-lBefore) / CLOCKS_PER_SEC;
  printf("\n Total Time: %12.3f sec.\n", dResult);

  // destroy application decoder class
  cTAppDecTop.destroy();

#if BIN_STATS
  {
    // Print out bin counters to stat file
    int i, j;
    FILE *stat_fp = fopen("bin_stat.txt", "w");
    for (i = 0; i < NUM_STAT_ENTRIES; i++)
    {
      for (j = 0; j < 2; j++)
      {
        fprintf(stat_fp, "%.0f ", bin_stat_arr[i][j]);
      }
      fprintf(stat_fp, "\n");
    }
    fclose(stat_fp);
  }

  {
    // Print out bin/pixels values derived from bin counters to stat file
    int i, j;
    double total_pixels = (double)num_pictures*(double)picture_width*(double)picture_height;
    FILE *stat_fp = fopen("bin_stat_bpp.txt", "w");
    for (i = 0; i < NUM_STAT_ENTRIES; i++)
    {
      for (j = 0; j < 2; j++)
      {
        fprintf(stat_fp, "%.10f ", (double)bin_stat_arr[i][j]/total_pixels);
      }
      fprintf(stat_fp, "\n");
    }
    fclose(stat_fp);
  }
  
  {
    // Print out max bin/pixels for pictures
    int i;
    double num_pixels = (double)picture_width*(double)picture_height;
    double max_bpp_intra_frm = 0;
    double max_bpp_inter_frm = 0;
    FILE *stat_fp = fopen("frm_bin_stat_bpp.txt", "w");
    FILE *stat_max_fp = fopen("max_bpp.txt", "w");
    // Compute number of bins for each frame
    for (i = num_pictures-1; i > 0; i--)
    {
      frm_bin_stat_arr[i][0] -= frm_bin_stat_arr[i-1][0];
      frm_bin_stat_arr[i][1] -= frm_bin_stat_arr[i-1][1];
    }
    //Compute bpp for each frame and find maximum bpp
    for (i = 0; i < num_pictures; i++)
    {
      double coded_bpp = frm_bin_stat_arr[i][0] / num_pixels;
      double bypass_bpp = frm_bin_stat_arr[i][1] / num_pixels;
      if ((frm_bin_stat_arr[i][2] == 'I') || (frm_bin_stat_arr[i][2] == 'i'))
      {
        max_bpp_intra_frm = max(max_bpp_intra_frm, coded_bpp);
      }
      else
      {
        max_bpp_inter_frm = max(max_bpp_inter_frm, coded_bpp);
      }
      fprintf(stat_fp, "%.10f %.10f\n", coded_bpp, bypass_bpp);
    }
    fprintf(stat_max_fp, "%.10f %.10f\n", max_bpp_intra_frm, max_bpp_inter_frm);
    fclose(stat_fp);
    fclose(stat_max_fp);
  }
#endif

  return g_md5_mismatch ? EXIT_FAILURE : EXIT_SUCCESS;
}

//! \}
